package rfid;

import gnu.io.*;
import java.io.*;
import java.util.*;

/**
 *
 * @author MY Haydary (yosuf419@hotmail.com)
 * Use under GNU licence
 */
public class SerialControllerRFID extends javax.swing.JFrame {

    private volatile InputStream in;
    private volatile OutputStream out;
    private volatile boolean connected = false;
    private volatile boolean tagReaderPermission = true;
    private volatile SerialPort serialPort;
    private tagReaderThread tag_reader_thread = null;

    public SerialControllerRFID() {
        initComponents();
        setLocationRelativeTo(null);
        setResizable(false);
        jButton5.setEnabled(false);
        jTextField1.setEnabled(false);

        jComboBox1.removeAllItems();
        Enumeration<?> commPorts = CommPortIdentifier.getPortIdentifiers();
        while (commPorts.hasMoreElements()) {
            CommPortIdentifier port = (CommPortIdentifier) commPorts.nextElement();
            jComboBox1.addItem(port.getName());

        }
        repaint();

    }

    public static void main(String args[]) {
        new SerialControllerRFID().setVisible(true);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jTextField1 = new javax.swing.JTextField();
        jButton5 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("RFID Controller by Yosuf");
        setResizable(false);

        jTextArea1.setColumns(30);
        jTextArea1.setRows(15);
        jTextArea1.setText("Welcome to RFID controller by Yosuf...\nA gift for Parallax forums.");
        jTextArea1.setToolTipText("Monitor to see what happens...");
        jScrollPane1.setViewportView(jTextArea1);

        jTextField1.setColumns(5);
        jTextField1.setToolTipText("Used for other purposes, not now ...");
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });

        jButton5.setText("Send command");
        jButton5.setToolTipText("for other purposes... use your own imagination :)");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jButton4.setText("Connect");
        jButton4.setToolTipText("Connect o disconnect the comport");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jButton1.setText("Clear Monitor");
        jButton1.setToolTipText("Clears the monitor above");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel1.setText("Monitor");

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBox1.setToolTipText("List of available Serial ports or Modem ports");
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButton4, javax.swing.GroupLayout.DEFAULT_SIZE, 96, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton1)
                        .addGap(14, 14, 14)
                        .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton5))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 517, Short.MAX_VALUE)
                    .addComponent(jLabel1))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton5)
                    .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton1)
                    .addComponent(jButton4)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    protected void appendln(String message) {
        jTextArea1.append(message + "\n");
    }

    protected class tagReaderThread extends Thread {

        public void run() {
            while (tagReaderPermission) {
                try {
                    while (in.available() > 0 && (connected)) {
                        String tagnr = "";
                        if (in.available() == 12) {
                            byte[] ea = new byte[in.available()];
                            in.read(ea);
                            tagnr = new String(ea, 1, 10);
                            appendln(tagnr);
                            //put a little delay between each reading
                            serialPort.setDTR(false);
                            Thread.sleep(1000);
                            serialPort.setDTR(true);
                        }

                    }
                } catch (Exception e) {
                }
            }
        }
    }

    private void connect_port(String portName) {
        try {
            Enumeration<?> commPorts = CommPortIdentifier.getPortIdentifiers();
//                appendln("Searching for RFID board...");
            while (commPorts.hasMoreElements() && !connected) {

                CommPortIdentifier port = (CommPortIdentifier) commPorts.nextElement();
                if ((port.getPortType() == CommPortIdentifier.PORT_SERIAL) && !port.isCurrentlyOwned()) {
                    CommPort commPort = port.open(this.getClass().getName(), 2000);
//                        appendln("port opened.");
                    if (commPort instanceof SerialPort) {
                        serialPort = (SerialPort) commPort;
//                            appendln("instance of serial port");
                        serialPort.setSerialPortParams(2400, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
//                            appendln("serial params set.");

                        in = serialPort.getInputStream();
                        out = serialPort.getOutputStream();
//                            Thread.sleep(200);
//                            appendln("Connecting to port: " + commPort.getName());

                        if (commPort.getName().equals("//./" + portName)) {
                            appendln("connected at port: " + portName);
                            connected = true;
                            tag_reader_thread = new tagReaderThread();
                            tag_reader_thread.start();
                            tagReaderPermission = true;
                            jButton4.setText("Disconnect");
                            jComboBox1.setEnabled(false);
                        } else {
                            in.close();
                            out.close();
                            serialPort.close();
                            commPort.close();
                        }

                    } else {
                        appendln("Error: Only serial ports are supported.");
                    }
                    Thread.sleep(100);
                } else {

//                    CommPort commPort = port.open(this.getClass().getName(), 2000);
                    appendln("Port might be in use");
                }
            }

        } catch (IOException e) {
            appendln("Error on connecting: " + e.getMessage());
        } catch (Exception e) {
            appendln("Error: " + e);
        }
    }



    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        //your own code.
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        if (connected) {
            tagReaderPermission = false;
            try {
                connected = false;
                in.close();
                out.close();
                serialPort.close();
                tagReaderThread temp = tag_reader_thread;
                tag_reader_thread = null;
                temp.interrupt();
                temp = null;
                appendln("port closed");
                jButton4.setText("Connect");
                jComboBox1.setEnabled(true);
            } catch (Exception e) {
                appendln("Error occured at closing input stream.");
            }
        } else if (!connected) {
            connect_port(jComboBox1.getSelectedItem().toString());
        }


    // TODO add your handling code here:
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        jTextArea1.setText("");        // TODO add your handling code here:
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBox1ActionPerformed
    /**
     * @param args the command line arguments
     */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables
}
